#include <stdbool.h>
#include "syntax.h"

typedef enum {

	REPLACE,
	FUNCTION

} tProcessingType;



typedef struct {

	char* replacethis;
	tSyntaxElement* replacewiththis;

} tProcessingReplace;

typedef struct {

	char** args;
	tSyntaxElement* body;

} tProcessingFunction;



typedef union {

	tProcessingReplace replace;
	tProcessingFunction function;

} tuProcessingData;

typedef struct ProcessingData {

	struct ProcessingData* prev;
	tProcessingType type;
	tuProcessingData data;

} tProcessingData;



void process(tSyntaxElement*, tProcessingData*);
